
local loader = require("generation/loader")
local loading = false
local loaded = false
local map = {}
local canvas

function love.load()
--[[
	loader.start(function(m)
		loading = false
		map = m
		canvas = love.graphics.newCanvas(800,600)
		love.graphics.setCanvas( canvas )
		for i = map.minx,map.maxx do
			for j = map.miny,map.maxy do
				if map[i][j] == 0 then
					love.graphics.rectangle("fill",i*2-map.minx*2,j*2-map.miny*2,2,2)
				end
			end
		end
		love.graphics.setCanvas()
	end,400,300)]]
end

function love.mousepressed(x,y,b)
	if not loaded then
		if x > 5 and x < 205 and y > 5 and y < 105 then
			loader.start(function(m) loading = false; map = m; canvas = love.graphics.newCanvas(800,600); love.graphics.setCanvas( canvas ); for i = map.minx,map.maxx do for j = map.miny,map.maxy do if map[i][j] == 0 then love.graphics.rectangle("fill",i*4-map.minx*4,j*4-map.miny*4,4,4); end; end; end; love.graphics.setCanvas(); end,200,150)
			loaded = true
			loading = true
		elseif x > 210 and x < 410 and y > 5 and y < 105 then
			loader.start(function(m) loading = false; map = m; canvas = love.graphics.newCanvas(800,600); love.graphics.setCanvas( canvas ); for i = map.minx,map.maxx do for j = map.miny,map.maxy do if map[i][j] == 0 then love.graphics.rectangle("fill",i*2-map.minx*2,j*2-map.miny*2,2,2); end; end; end; love.graphics.setCanvas(); end,400,300)
			loaded = true
			loading = true
		elseif x > 415 and x < 615 and y > 5 and y < 105 then
			loader.start(function(m) loading = false; map = m; canvas = love.graphics.newCanvas(800,600); love.graphics.setCanvas( canvas ); for i = map.minx,map.maxx do for j = map.miny,map.maxy do if map[i][j] == 0 then love.graphics.rectangle("fill",i*1-map.minx*1,j*1-map.miny*1,1,1); end; end; end; love.graphics.setCanvas(); end,800,600)
			loaded = true
			loading = true
		end
	end
end

function love.update(dt)
	if loading then
		loader.update(dt)
	end
end

function love.draw()
	if not loaded then
		love.graphics.rectangle("line",5,5,200,100)
		love.graphics.rectangle("line",210,5,200,100)
		love.graphics.rectangle("line",415,5,200,100)
		love.graphics.print("200x150",10,10)
		love.graphics.print("400x300",215,10)
		love.graphics.print("800x600",420,10)
	end
	if map.minx then
		love.graphics.draw(canvas)
	elseif loaded then
		love.graphics.print(math.min(100,math.floor(loader.getDone()*10000)/100),0,0)
		for i,v in ipairs(loader.getActions()) do
			love.graphics.print(v,0,i*20)
		end
	end
end
